diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFlowerStackable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlowerStackable.java
similarity index 91%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFlowerStackable.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFlowerStackable.java
index a5f24c6f8..7dd71a5a9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFlowerStackable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlowerStackable.java
@@ -12,13 +12,13 @@ import org.jetbrains.annotations.Nullable;
 /**
  * Represents a flower block that can store multiple flowers within itself, up to a maximum of 4.
  */
-public class BlockFlowerStackable extends BlockFlower {
+public class BlockLogicFlowerStackable extends BlockLogicFlower {
     public static final int MASK_STACK_COUNT = 0b0110_0000;
     public static final int OFFSET_STACK_COUNT = 5;
     public static final int MAX_STACK_COUNT = MASK_STACK_COUNT >> OFFSET_STACK_COUNT;
 
-    public BlockFlowerStackable(String key, String namespaceId, int id) {
-        super(key, namespaceId, id);
+    public BlockLogicFlowerStackable(Block<?> block) {
+        super(block);
     }
 
     @Override
@@ -49,13 +49,13 @@ public class BlockFlowerStackable extends BlockFlower {
         }
 
         final ItemStack heldItem = player.getHeldItem();
-        if (heldItem == null || heldItem.stackSize < 1 || heldItem.getItem().id != this.id) {
+        if (heldItem == null || heldItem.stackSize < 1 || heldItem.getItem().id != block.id()) {
             return false;
         }
 
         final int newMetadata = setPermanent(setStackCount(metadata, currentStackCount + 1), true);
         world.setBlockMetadataWithNotify(x, y, z, newMetadata);
-        world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
+        world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, block, EnumBlockSoundEffectType.PLACE);
         heldItem.consumeItem(player);
         return true;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
similarity index 86%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFluid.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index 86a1cf1a6..5d61e5660 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -15,14 +15,14 @@ import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
-public abstract class BlockFluid extends Block
+public abstract class BlockLogicFluid extends BlockLogic
 {
 
-	public BlockFluid(String key, String namespaceId, int id, Material material)
+	public BlockLogicFluid(Block<?> block, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-        setTicking(true);
+        block.setTicking(true);
     }
 
     public static float getWaterVolume(int data)
@@ -37,7 +37,7 @@ public abstract class BlockFluid extends Block
 
     protected int getDepth(WorldSource world, int x, int y, int z)
     {
-        if(world.getBlockMaterial(x, y, z) != blockMaterial)
+        if(world.getBlockMaterial(x, y, z) != material)
         {
             return -1;
         }
@@ -49,7 +49,7 @@ public abstract class BlockFluid extends Block
 
     protected int getRenderedDepth(WorldSource blockAccess, int x, int y, int z)
     {
-        if (blockAccess.getBlockMaterial(x, y, z) != blockMaterial)
+        if (blockAccess.getBlockMaterial(x, y, z) != material)
         {
             return -1;
         }
@@ -83,7 +83,7 @@ public abstract class BlockFluid extends Block
     public boolean getIsBlockSolid(WorldSource blockAccess, int x, int y, int z, Side side)
     {
         Material material = blockAccess.getBlockMaterial(x, y, z);
-        if(material == blockMaterial)
+        if(material == this.material)
         {
             return false;
         }
@@ -170,11 +170,11 @@ public abstract class BlockFluid extends Block
     @Override
     public int tickDelay()
     {
-        if(blockMaterial == Material.water)
+        if(material == Material.water)
         {
             return 5;
         }
-        return blockMaterial != Material.lava ? 0 : 30;
+        return material != Material.lava ? 0 : 30;
     }
 
     @Override
@@ -194,7 +194,7 @@ public abstract class BlockFluid extends Block
     @Override
     public void animationTick(World world, int x, int y, int z, Random rand)
     {
-        if(blockMaterial == Material.water && rand.nextInt(64) == 0)
+        if(material == Material.water && rand.nextInt(64) == 0)
         {
             int data = world.getBlockMetadata(x, y, z) & 0x0F;
             if(data > 0 && data < 8)
@@ -202,7 +202,7 @@ public abstract class BlockFluid extends Block
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) x + 0.5F, (float) y + 0.5F, (float) z + 0.5F, "liquid.water", rand.nextFloat() * 0.25F + 0.75F, rand.nextFloat() * 1.0F + 0.5F);
             }
         }
-        if(blockMaterial == Material.lava && world.getBlockMaterial(x, y + 1, z) == Material.air && !world.isBlockOpaqueCube(x, y + 1, z) && rand.nextInt(100) == 0)
+        if(material == Material.lava && world.getBlockMaterial(x, y + 1, z) == Material.air && !world.isBlockOpaqueCube(x, y + 1, z) && rand.nextInt(100) == 0)
         {
             double xOff = (double) x + rand.nextFloat();
             double yOff = (double) y + getBounds().maxY;
@@ -216,11 +216,11 @@ public abstract class BlockFluid extends Block
         Vec3 vec3 = null;
         if(material == Material.water)
         {
-            vec3 = ((BlockFluid)Blocks.FLUID_WATER_FLOWING).getFlow(blockAccess, x, y, z);
+            vec3 = Blocks.FLUID_WATER_FLOWING.getLogic().getFlow(blockAccess, x, y, z);
         }
         if(material == Material.lava)
         {
-            vec3 = ((BlockFluid)Blocks.FLUID_LAVA_FLOWING).getFlow(blockAccess, x, y, z);
+            vec3 = Blocks.FLUID_LAVA_FLOWING.getLogic().getFlow(blockAccess, x, y, z);
         }
         if(vec3 == null ||(vec3.x == 0.0D && vec3.z == 0.0D))
         {
@@ -245,11 +245,11 @@ public abstract class BlockFluid extends Block
 
     private void checkForHarden(World world, int x, int y, int z)
     {
-        if(world.getBlockId(x, y, z) != id)
+        if(world.getBlockId(x, y, z) != block.id())
         {
             return;
         }
-        if(blockMaterial == Material.lava)
+        if(material == Material.lava)
         {
             if(world.getBlockMaterial(x, y, z - 1) == Material.water ||
                 world.getBlockMaterial(x, y, z + 1) == Material.water ||
@@ -261,28 +261,28 @@ public abstract class BlockFluid extends Block
                 if(data == 0)
                 {
                     if (world.dimension == Dimension.NETHER) {
-                        world.setBlockWithNotify(x, y, z, Blocks.COBBLE_NETHERRACK_IGNEOUS.id);
+                        world.setBlockWithNotify(x, y, z, Blocks.COBBLE_NETHERRACK_IGNEOUS.id());
                     } else {
-                        world.setBlockWithNotify(x, y, z, Blocks.OBSIDIAN.id);
+                        world.setBlockWithNotify(x, y, z, Blocks.OBSIDIAN.id());
                     }
                 }
                 else if(data <= 2)
                 {
-                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_GRANITE.id);
+                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_GRANITE.id());
                 }
                 else if(data <= 4)
                 {
-                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_STONE.id);
+                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_STONE.id());
                 }
                 else
                 {
-                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_BASALT.id);
+                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_BASALT.id());
                 }
                 fizz(world, x, y, z);
             }
         }
 
-        if(blockMaterial == Material.water)
+        if(material == Material.water)
         {
             if(world.getBlockMaterial(x, y, z - 1) == Material.lava ||
                 world.getBlockMaterial(x, y, z + 1) == Material.lava ||
@@ -293,7 +293,7 @@ public abstract class BlockFluid extends Block
                 int data = world.getBlockMetadata(x, y, z) & 0x0F;
                 if(data == 0)
                 {
-                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_LIMESTONE.id);
+                    world.setBlockWithNotify(x, y, z, Blocks.COBBLE_LIMESTONE.id());
                     fizz(world, x, y, z);
                 }
             }
@@ -317,10 +317,10 @@ public abstract class BlockFluid extends Block
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-        float f7 = BlockFluid.getFluidHeight(world, x, y, z, blockMaterial);
-        float f8 = BlockFluid.getFluidHeight(world, x, y, z + 1, blockMaterial);
-        float f9 = BlockFluid.getFluidHeight(world, x + 1, y, z + 1, blockMaterial);
-        float f10 = BlockFluid.getFluidHeight(world, x + 1, y, z, blockMaterial);
+        float f7 = BlockLogicFluid.getFluidHeight(world, x, y, z, material);
+        float f8 = BlockLogicFluid.getFluidHeight(world, x, y, z + 1, material);
+        float f9 = BlockLogicFluid.getFluidHeight(world, x + 1, y, z + 1, material);
+        float f10 = BlockLogicFluid.getFluidHeight(world, x + 1, y, z, material);
         return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, Math.max((f7 + f8 + f9 + f10)/4f, 0.2), 1.0F);
     }
 
@@ -342,10 +342,10 @@ public abstract class BlockFluid extends Block
                 int i2 = worldSource.getBlockMetadata(j1, y, l1);
                 if(i2 >= 8 || i2 == 0)
                 {
-                    f += BlockFluid.getWaterVolume(i2) * 10F;
+                    f += BlockLogicFluid.getWaterVolume(i2) * 10F;
                     l += 10;
                 }
-                f += BlockFluid.getWaterVolume(i2);
+                f += BlockLogicFluid.getWaterVolume(i2);
                 l++;
                 continue;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
similarity index 85%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
index 05ee752f9..9643fe9f3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
@@ -8,25 +8,26 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockFluidFlowing extends BlockFluid
+public class BlockLogicFluidFlowing extends BlockLogicFluid
 {
     int maxCount;
     boolean[] result;
     int[] distance;
+    public final Block<?> blockStill;
 
-
-	public BlockFluidFlowing(String key, String namespaceId, int id, Material material)
+	public BlockLogicFluidFlowing(Block<?> block, Material material, Block<?> blockStill)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
         maxCount = 0;
         result = new boolean[4];
         distance = new int[4];
+        this.blockStill = blockStill;
     }
 
     private void setFluidStill(World world, int x, int y, int z)
     {
         int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockAndMetadata(x, y, z, id + 1, meta);
+        world.setBlockAndMetadata(x, y, z, blockStill.id(), meta);
         world.markBlocksDirty(x, y, z, x, y, z);
         world.markBlockNeedsUpdate(x, y, z);
     }
@@ -36,7 +37,7 @@ public class BlockFluidFlowing extends BlockFluid
     {
         int localFlowDecay = getDepth(world, x, y, z);
         byte flowDecayMod = 1;
-        if(blockMaterial == Material.lava && world.dimension != Dimension.NETHER)
+        if(material == Material.lava && world.dimension != Dimension.NETHER)
         {
             flowDecayMod = 2;
         }
@@ -64,13 +65,13 @@ public class BlockFluidFlowing extends BlockFluid
                     newFlowDecay = flowDecayAbove + 8;
                 }
             }
-            if(maxCount >= 2 && blockMaterial == Material.water)
+            if(maxCount >= 2 && material == Material.water)
             {
                 if(world.getBlockMaterial(x, y - 1, z).isSolid())
                 {
                     newFlowDecay = 0;
                 }
-                else if(world.getBlockMaterial(x, y - 1, z) == blockMaterial && world.getBlockMetadata(x, y - 1, z) == 0)
+                else if(world.getBlockMaterial(x, y - 1, z) == material && world.getBlockMetadata(x, y - 1, z) == 0)
                 {
                     newFlowDecay = 0;
                 }
@@ -85,8 +86,8 @@ public class BlockFluidFlowing extends BlockFluid
                 else
                 {
                     world.setBlockMetadataWithNotify(x, y, z, localFlowDecay);
-                    world.scheduleBlockUpdate(x, y, z, id, tickDelay());
-                    world.notifyBlocksOfNeighborChange(x, y, z, id);
+                    world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
+                    world.notifyBlocksOfNeighborChange(x, y, z, block.id());
                 }
             }
             else
@@ -107,9 +108,9 @@ public class BlockFluidFlowing extends BlockFluid
                 Blocks.blocksList[id].dropBlockWithCause(world, EnumDropCause.WORLD, x, y - 1, z, meta, null, null);
         	}
             if(localFlowDecay >= 8) {
-                world.setBlockAndMetadataWithNotify(x, y - 1, z, this.id, localFlowDecay);
+                world.setBlockAndMetadataWithNotify(x, y - 1, z, block.id(), localFlowDecay);
             } else {
-                world.setBlockAndMetadataWithNotify(x, y - 1, z, this.id, localFlowDecay + 8);
+                world.setBlockAndMetadataWithNotify(x, y - 1, z, block.id(), localFlowDecay + 8);
             }
         } else
         if(localFlowDecay >= 0 && (localFlowDecay == 0 || isFluidBlocking(world, x, y - 1, z)))
@@ -150,7 +151,7 @@ public class BlockFluidFlowing extends BlockFluid
             int i1 = world.getBlockId(x, y, z);
             if(i1 > 0)
             {
-                if(blockMaterial == Material.lava)
+                if(material == Material.lava)
                 {
                     fizz(world, x, y, z);
                 } else
@@ -158,7 +159,7 @@ public class BlockFluidFlowing extends BlockFluid
                     Blocks.blocksList[i1].dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
                 }
             }
-            world.setBlockAndMetadataWithNotify(x, y, z, id, meta);
+            world.setBlockAndMetadataWithNotify(x, y, z, block.id(), meta);
         }
     }
 
@@ -190,7 +191,7 @@ public class BlockFluidFlowing extends BlockFluid
             {
                 z2++;
             }
-            if(isFluidBlocking(world, x2, y2, z2) || world.getBlockMaterial(x2, y2, z2) == blockMaterial && world.getBlockMetadata(x2, y2, z2) == 0)
+            if(isFluidBlocking(world, x2, y2, z2) || world.getBlockMaterial(x2, y2, z2) == material && world.getBlockMetadata(x2, y2, z2) == 0)
             {
                 continue;
             }
@@ -236,7 +237,7 @@ public class BlockFluidFlowing extends BlockFluid
             {
                 z2++;
             }
-            if(isFluidBlocking(world, x2, y2, z2) || world.getBlockMaterial(x2, y2, z2) == blockMaterial && world.getBlockMetadata(x2, y2, z2) == 0)
+            if(isFluidBlocking(world, x2, y2, z2) || world.getBlockMaterial(x2, y2, z2) == material && world.getBlockMetadata(x2, y2, z2) == 0)
             {
                 continue;
             }
@@ -268,9 +269,8 @@ public class BlockFluidFlowing extends BlockFluid
 
     private boolean isFluidBlocking(World world, int x, int y, int z)
     {
-        int id = world.getBlockId(x, y, z);
-        if (Blocks.blocksList[id] == null || Blocks.blocksList[id] instanceof BlockFluid || Blocks.blocksList[id].hasTag(BlockTags.BROKEN_BY_FLUIDS)) return false;
-        return true;
+        Block<?> b = world.getBlock(x, y, z);
+        return b != null && !(b.getLogic() instanceof BlockLogicFluid) && !b.hasTag(BlockTags.BROKEN_BY_FLUIDS);
     }
 
     protected int getHighest(World world, int x, int y, int z, int currentFlowDecay)
@@ -294,7 +294,7 @@ public class BlockFluidFlowing extends BlockFluid
     private boolean canSpreadTo(World world, int x, int y, int z)
     {
         Material material = world.getBlockMaterial(x, y, z);
-        if(material == blockMaterial)
+        if(material == this.material)
         {
             return false;
         }
@@ -312,9 +312,9 @@ public class BlockFluidFlowing extends BlockFluid
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
         super.onBlockPlacedByWorld(world, x, y, z);
-        if(world.getBlockId(x, y, z) == id)
+        if(world.getBlockId(x, y, z) == block.id())
         {
-            world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+            world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFluidStill.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
similarity index 73%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFluidStill.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
index 08d24723c..3bc15bae9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFluidStill.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
@@ -5,17 +5,16 @@ import java.util.Random;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-public class BlockFluidStill extends BlockFluid
+
+public class BlockLogicFluidStill extends BlockLogicFluid
 {
+    public final Block<?> blockFlowing;
 
-	public BlockFluidStill(String key, String namespaceId, int id, Material material)
+	public BlockLogicFluidStill(Block<?> block, Material material, Block<?> blockFlowing)
     {
-        super(key, namespaceId, id, material);
-        setTicking(false);
-        if(material == Material.lava)
-        {
-            setTicking(true);
-        }
+        super(block, material);
+        block.setTicking(material == Material.lava);
+        this.blockFlowing = blockFlowing;
     }
 
     @Override
@@ -23,7 +22,7 @@ public class BlockFluidStill extends BlockFluid
     {
         super.onNeighborBlockChange(world, x, y, z, blockId);
         if (blockId == Side.TOP.getId()) return;
-        if(world.getBlockId(x, y, z) == id)
+        if(world.getBlockId(x, y, z) == block.id())
         {
             setFlowing(world, x, y, z);
         }
@@ -33,16 +32,16 @@ public class BlockFluidStill extends BlockFluid
     {
         int meta = world.getBlockMetadata(x, y, z);
         world.noNeighborUpdate = true;
-        world.setBlockAndMetadata(x, y, z, id - 1, meta);
+        world.setBlockAndMetadata(x, y, z, blockFlowing.id(), meta);
         world.markBlocksDirty(x, y, z, x, y, z);
-        world.scheduleBlockUpdate(x, y, z, id - 1, tickDelay());
+        world.scheduleBlockUpdate(x, y, z, blockFlowing.id(), tickDelay());
         world.noNeighborUpdate = false;
     }
 
     @Override
 	public void updateTick(World world, int x, int y, int z, Random rand)
     {
-        if(blockMaterial == Material.lava)
+        if(material == Material.lava)
         {
             int l = rand.nextInt(3);
             for(int i1 = 0; i1 < l; i1++)
@@ -55,12 +54,12 @@ public class BlockFluidStill extends BlockFluid
                 {
                     if(isFlammable(world, x - 1, y, z) || isFlammable(world, x + 1, y, z) || isFlammable(world, x, y, z - 1) || isFlammable(world, x, y, z + 1) || isFlammable(world, x, y - 1, z) || isFlammable(world, x, y + 1, z))
                     {
-                        world.setBlockWithNotify(x, y, z, Blocks.FIRE.id);
+                        world.setBlockWithNotify(x, y, z, Blocks.FIRE.id());
                         return;
                     }
                     continue;
                 }
-                if(Blocks.blocksList[blockId].blockMaterial.blocksMotion())
+                if(Blocks.blocksList[blockId].getMaterial().blocksMotion())
                 {
                     return;
                 }
@@ -71,6 +70,6 @@ public class BlockFluidStill extends BlockFluid
 
     private boolean isFlammable(World world, int x, int y, int z)
     {
-        return BlockFire.canBurn(world, x, y, z);
+        return BlockLogicFire.canBurn(world, x, y, z);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFullyRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFullyRotatable.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
index 16a5ec55e..6c11d72ce 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFullyRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFullyRotatable.java
@@ -7,10 +7,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public abstract class BlockFullyRotatable extends Block {
+public class BlockLogicFullyRotatable extends BlockLogic {
     public static final int MASK_DIRECTION = 0b0000_0111;
-    public BlockFullyRotatable(String translationKey, String namespaceId, int id, Material material) {
-        super(translationKey, namespaceId, id, material);
+    public BlockLogicFullyRotatable(Block<?> block, Material material) {
+        super(block, material);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFurnace.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
similarity index 92%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFurnace.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
index f063c0e83..bd351d32a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
@@ -15,13 +15,14 @@ import org.slf4j.Logger;
 
 import java.util.Random;
 
-public class BlockFurnace extends BlockTileEntityRotatable
+public class BlockLogicFurnace extends BlockLogicRotatable
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-	public BlockFurnace(String key, String namespaceId, int id, boolean flag)
+	public BlockLogicFurnace(Block<?> block, boolean active)
     {
-        super(key, namespaceId, id, Material.stone);
-        isActive = flag;
+        super(block, Material.stone);
+        isActive = active;
+        block.withEntity(TileEntityFurnace::new);
     }
 
     @Override
@@ -99,9 +100,9 @@ public class BlockFurnace extends BlockTileEntityRotatable
 		}
 		keepFurnaceInventory = true;
 		if(lit) {
-			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_STONE_ACTIVE.id);
+			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_STONE_ACTIVE.id());
 		} else {
-			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_STONE_IDLE.id);
+			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_STONE_IDLE.id());
 		}
 		keepFurnaceInventory = false;
 		world.setBlockMetadataWithNotify(x, y, z, meta);
@@ -109,12 +110,6 @@ public class BlockFurnace extends BlockTileEntityRotatable
 		world.setBlockTileEntity(x, y, z, tileEntity);
 	}
 
-    @Override
-	protected TileEntity getNewBlockEntity()
-    {
-        return new TileEntityFurnace();
-    }
-
     protected Random furnaceRand;
     protected final boolean isActive;
     public static boolean keepFurnaceInventory = false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
similarity index 85%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFurnaceBlast.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
index 9cccd3117..643132270 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
@@ -3,7 +3,7 @@ package net.minecraft.core.block;
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityFurnaceBlastFurnace;
+import net.minecraft.core.block.entity.TileEntityFurnaceBlast;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -13,13 +13,14 @@ import org.slf4j.Logger;
 
 import java.util.Random;
 
-public class BlockFurnaceBlast extends BlockFurnace
+public class BlockLogicFurnaceBlast extends BlockLogicFurnace
 {
     private static final Logger LOGGER = LogUtils.getLogger();
 
-	public BlockFurnaceBlast(String key, String namespaceId, int id, boolean flag)
+	public BlockLogicFurnaceBlast(Block<?> block, boolean flag)
     {
-        super(key, namespaceId, id, flag);
+        super(block, flag);
+        block.withEntity(TileEntityFurnaceBlast::new);
     }
 
     @Override
@@ -41,8 +42,8 @@ public class BlockFurnaceBlast extends BlockFurnace
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
-            TileEntityFurnaceBlastFurnace tileentityblastfurnace = (TileEntityFurnaceBlastFurnace) world.getBlockEntity(x, y, z);
-            player.displayFurnaceScreen(tileentityblastfurnace);
+            TileEntityFurnaceBlast furnaceBlast = (TileEntityFurnaceBlast) world.getBlockEntity(x, y, z);
+            player.displayFurnaceScreen(furnaceBlast);
         }
         return true;
     }
@@ -96,9 +97,9 @@ public class BlockFurnaceBlast extends BlockFurnace
 		}
 		keepFurnaceInventory = true;
 		if(lit) {
-			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_BLAST_ACTIVE.id);
+			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_BLAST_ACTIVE.id());
 		} else {
-			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_BLAST_IDLE.id);
+			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_BLAST_IDLE.id());
 		}
 		keepFurnaceInventory = false;
 		world.setBlockMetadataWithNotify(x, y, z, meta);
@@ -106,10 +107,4 @@ public class BlockFurnaceBlast extends BlockFurnace
 		world.setBlockTileEntity(x, y, z, tileEntity);
 	}
 
-    @Override
-	protected TileEntity getNewBlockEntity()
-    {
-        return new TileEntityFurnaceBlastFurnace();
-    }
-
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockGlass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlass.java
similarity index 78%
rename from game/core/src/main/java/net/minecraft/core/block/BlockGlass.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicGlass.java
index 5b90ae5c6..cd77979c4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockGlass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlass.java
@@ -6,12 +6,12 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class BlockGlass extends BlockTransparent
+public class BlockLogicGlass extends BlockLogicTransparent
 {
 
-    public BlockGlass(String key, String namespaceId, int id, Material material)
+    public BlockLogicGlass(Block<?> block, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockGlassTinted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlassTinted.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockGlassTinted.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicGlassTinted.java
index e9139b829..686f63bc8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockGlassTinted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlassTinted.java
@@ -6,12 +6,12 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-public class BlockGlassTinted extends BlockGlass
+public class BlockLogicGlassTinted extends BlockLogicGlass
 {
 
-    public BlockGlassTinted(String key, String namespaceID, int id)
+    public BlockLogicGlassTinted(Block<?> block)
     {
-        super(key, namespaceID, id, Material.glass);
+        super(block, Material.glass);
     }
 
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockGlowStone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlowStone.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/block/BlockGlowStone.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicGlowStone.java
index 01954344b..00691447e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockGlowStone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGlowStone.java
@@ -8,12 +8,12 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockGlowStone extends Block
+public class BlockLogicGlowStone extends BlockLogic
 {
 
-    public BlockGlowStone(String key, String namespaceId, int id, Material material)
+    public BlockLogicGlowStone(Block<?> block, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
     }
 
     @Override
